
package zoomarket;

import javax.swing.JOptionPane;


public class AdminArea extends javax.swing.JFrame {
    private UserManager users;
	private Catalogue products;
	
	private final String fileUsers = "users";
	private final String fileProducts = "products";

    /** Creates new form AdminArea */
    public AdminArea() {
        initComponents();

        users = new UserManager();
		products = new Catalogue();

		txtUsersFileName.setText(fileUsers);
		txtProductsFileName.setText(fileProducts);
		clearProductFields(); // Set zeros in the number fields.

        reloadRepositories();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        bindingGroup = new org.jdesktop.beansbinding.BindingGroup();

        txtUsername = new javax.swing.JTextField();
        txtPassword = new javax.swing.JTextField();
        btnAddUser = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        txtareaUsers = new javax.swing.JTextArea();
        btnOpenUsersRepo = new javax.swing.JButton();
        btnSaveUsersRepo = new javax.swing.JButton();
        btnAddUsersRepo = new javax.swing.JButton();
        txtUsersFileName = new javax.swing.JTextField();
        btnClearUsersRepo = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        txtProductName = new javax.swing.JTextField();
        lblProductName = new javax.swing.JLabel();
        lblDescription = new javax.swing.JLabel();
        lblManufacturer = new javax.swing.JLabel();
        txtManufacturer = new javax.swing.JTextField();
        lblProductType = new javax.swing.JLabel();
        txtProductType = new javax.swing.JTextField();
        lblQuantity = new javax.swing.JLabel();
        lblPrice = new javax.swing.JLabel();
        txtPrice = new javax.swing.JTextField();
        lblVipPrice = new javax.swing.JLabel();
        txtVipPrice = new javax.swing.JTextField();
        txtQuantity = new javax.swing.JTextField();
        btnAddProduct = new javax.swing.JButton();
        jScrollPane2 = new javax.swing.JScrollPane();
        txtareaProducts = new javax.swing.JTextArea();
        jLabel11 = new javax.swing.JLabel();
        jLabel12 = new javax.swing.JLabel();
        lblRemoveProductId = new javax.swing.JLabel();
        txtProductId = new javax.swing.JTextField();
        btnRemoveProduct = new javax.swing.JButton();
        lblRemoveUserId = new javax.swing.JLabel();
        txtUserId = new javax.swing.JTextField();
        btnRemoveUser = new javax.swing.JButton();
        btnClearProductsRepo = new javax.swing.JButton();
        btnSaveProductsRepo = new javax.swing.JButton();
        btnAddProductsRepo = new javax.swing.JButton();
        btnOpenProductsRepo = new javax.swing.JButton();
        txtProductsFileName = new javax.swing.JTextField();
        lblProductsFile = new javax.swing.JLabel();
        lblUsersFile = new javax.swing.JLabel();
        cmbUserType = new javax.swing.JComboBox();
        btnRemoveReview = new javax.swing.JButton();
        txtReviewId = new javax.swing.JTextField();
        lblRemoveReviewId = new javax.swing.JLabel();
        btnRefresh = new javax.swing.JButton();
        cmbDescription = new javax.swing.JComboBox();
        btnEditUser = new javax.swing.JButton();
        btnEditProduct = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        org.jdesktop.beansbinding.Binding binding = org.jdesktop.beansbinding.Bindings.createAutoBinding(org.jdesktop.beansbinding.AutoBinding.UpdateStrategy.READ_WRITE, txtPassword, org.jdesktop.beansbinding.ObjectProperty.create(), txtUsername, org.jdesktop.beansbinding.BeanProperty.create("nextFocusableComponent"));
        bindingGroup.addBinding(binding);

        binding = org.jdesktop.beansbinding.Bindings.createAutoBinding(org.jdesktop.beansbinding.AutoBinding.UpdateStrategy.READ_WRITE, cmbUserType, org.jdesktop.beansbinding.ObjectProperty.create(), txtPassword, org.jdesktop.beansbinding.BeanProperty.create("nextFocusableComponent"));
        bindingGroup.addBinding(binding);

        btnAddUser.setText("Add user");

        binding = org.jdesktop.beansbinding.Bindings.createAutoBinding(org.jdesktop.beansbinding.AutoBinding.UpdateStrategy.READ_WRITE, txtUserId, org.jdesktop.beansbinding.ObjectProperty.create(), btnAddUser, org.jdesktop.beansbinding.BeanProperty.create("nextFocusableComponent"));
        bindingGroup.addBinding(binding);

        btnAddUser.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnAddUserActionPerformed(evt);
            }
        });

        txtareaUsers.setColumns(20);
        txtareaUsers.setRows(5);

        binding = org.jdesktop.beansbinding.Bindings.createAutoBinding(org.jdesktop.beansbinding.AutoBinding.UpdateStrategy.READ_WRITE, txtUsername, org.jdesktop.beansbinding.ObjectProperty.create(), txtareaUsers, org.jdesktop.beansbinding.BeanProperty.create("nextFocusableComponent"));
        bindingGroup.addBinding(binding);

        jScrollPane1.setViewportView(txtareaUsers);

        btnOpenUsersRepo.setText("Open users repository");

        binding = org.jdesktop.beansbinding.Bindings.createAutoBinding(org.jdesktop.beansbinding.AutoBinding.UpdateStrategy.READ_WRITE, btnAddUsersRepo, org.jdesktop.beansbinding.ObjectProperty.create(), btnOpenUsersRepo, org.jdesktop.beansbinding.BeanProperty.create("nextFocusableComponent"));
        bindingGroup.addBinding(binding);

        btnOpenUsersRepo.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnOpenUsersRepoActionPerformed(evt);
            }
        });

        btnSaveUsersRepo.setText("Save users repository");

        binding = org.jdesktop.beansbinding.Bindings.createAutoBinding(org.jdesktop.beansbinding.AutoBinding.UpdateStrategy.READ_WRITE, btnClearUsersRepo, org.jdesktop.beansbinding.ObjectProperty.create(), btnSaveUsersRepo, org.jdesktop.beansbinding.BeanProperty.create("nextFocusableComponent"));
        bindingGroup.addBinding(binding);

        btnSaveUsersRepo.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnSaveUsersRepoActionPerformed(evt);
            }
        });

        btnAddUsersRepo.setText("Add users repository");

        binding = org.jdesktop.beansbinding.Bindings.createAutoBinding(org.jdesktop.beansbinding.AutoBinding.UpdateStrategy.READ_WRITE, btnSaveUsersRepo, org.jdesktop.beansbinding.ObjectProperty.create(), btnAddUsersRepo, org.jdesktop.beansbinding.BeanProperty.create("nextFocusableComponent"));
        bindingGroup.addBinding(binding);

        btnAddUsersRepo.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnAddUsersRepoActionPerformed(evt);
            }
        });

        binding = org.jdesktop.beansbinding.Bindings.createAutoBinding(org.jdesktop.beansbinding.AutoBinding.UpdateStrategy.READ_WRITE, btnOpenUsersRepo, org.jdesktop.beansbinding.ObjectProperty.create(), txtUsersFileName, org.jdesktop.beansbinding.BeanProperty.create("nextFocusableComponent"));
        bindingGroup.addBinding(binding);

        btnClearUsersRepo.setText("Clear users repository");

        binding = org.jdesktop.beansbinding.Bindings.createAutoBinding(org.jdesktop.beansbinding.AutoBinding.UpdateStrategy.READ_WRITE, txtProductName, org.jdesktop.beansbinding.ObjectProperty.create(), btnClearUsersRepo, org.jdesktop.beansbinding.BeanProperty.create("nextFocusableComponent"));
        bindingGroup.addBinding(binding);

        btnClearUsersRepo.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnClearUsersRepoActionPerformed(evt);
            }
        });

        jLabel1.setText("Username :");

        jLabel2.setText("Password :");

        jLabel3.setText("UserType :");

        binding = org.jdesktop.beansbinding.Bindings.createAutoBinding(org.jdesktop.beansbinding.AutoBinding.UpdateStrategy.READ_WRITE, txtManufacturer, org.jdesktop.beansbinding.ObjectProperty.create(), txtProductName, org.jdesktop.beansbinding.BeanProperty.create("nextFocusableComponent"));
        bindingGroup.addBinding(binding);

        lblProductName.setText("Product name :");

        lblDescription.setText("Description :");

        lblManufacturer.setText("Manufacturer :");

        binding = org.jdesktop.beansbinding.Bindings.createAutoBinding(org.jdesktop.beansbinding.AutoBinding.UpdateStrategy.READ_WRITE, txtProductType, org.jdesktop.beansbinding.ObjectProperty.create(), txtManufacturer, org.jdesktop.beansbinding.BeanProperty.create("nextFocusableComponent"));
        bindingGroup.addBinding(binding);

        lblProductType.setText("Product type :");

        binding = org.jdesktop.beansbinding.Bindings.createAutoBinding(org.jdesktop.beansbinding.AutoBinding.UpdateStrategy.READ_WRITE, cmbDescription, org.jdesktop.beansbinding.ObjectProperty.create(), txtProductType, org.jdesktop.beansbinding.BeanProperty.create("nextFocusableComponent"));
        bindingGroup.addBinding(binding);

        txtProductType.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                txtProductTypeActionPerformed(evt);
            }
        });

        lblQuantity.setText("Quantity :");

        lblPrice.setText("Price :");

        binding = org.jdesktop.beansbinding.Bindings.createAutoBinding(org.jdesktop.beansbinding.AutoBinding.UpdateStrategy.READ_WRITE, txtVipPrice, org.jdesktop.beansbinding.ObjectProperty.create(), txtPrice, org.jdesktop.beansbinding.BeanProperty.create("nextFocusableComponent"));
        bindingGroup.addBinding(binding);

        lblVipPrice.setText("Vip price :");

        binding = org.jdesktop.beansbinding.Bindings.createAutoBinding(org.jdesktop.beansbinding.AutoBinding.UpdateStrategy.READ_WRITE, btnAddProduct, org.jdesktop.beansbinding.ObjectProperty.create(), txtVipPrice, org.jdesktop.beansbinding.BeanProperty.create("nextFocusableComponent"));
        bindingGroup.addBinding(binding);

        binding = org.jdesktop.beansbinding.Bindings.createAutoBinding(org.jdesktop.beansbinding.AutoBinding.UpdateStrategy.READ_WRITE, txtPrice, org.jdesktop.beansbinding.ObjectProperty.create(), txtQuantity, org.jdesktop.beansbinding.BeanProperty.create("nextFocusableComponent"));
        bindingGroup.addBinding(binding);

        btnAddProduct.setText("Add product");

        binding = org.jdesktop.beansbinding.Bindings.createAutoBinding(org.jdesktop.beansbinding.AutoBinding.UpdateStrategy.READ_WRITE, txtProductId, org.jdesktop.beansbinding.ObjectProperty.create(), btnAddProduct, org.jdesktop.beansbinding.BeanProperty.create("nextFocusableComponent"));
        bindingGroup.addBinding(binding);

        btnAddProduct.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnAddProductActionPerformed(evt);
            }
        });

        txtareaProducts.setColumns(20);
        txtareaProducts.setRows(5);

        binding = org.jdesktop.beansbinding.Bindings.createAutoBinding(org.jdesktop.beansbinding.AutoBinding.UpdateStrategy.READ_WRITE, txtProductName, org.jdesktop.beansbinding.ObjectProperty.create(), txtareaProducts, org.jdesktop.beansbinding.BeanProperty.create("nextFocusableComponent"));
        bindingGroup.addBinding(binding);

        jScrollPane2.setViewportView(txtareaProducts);

        jLabel11.setText("Users");

        jLabel12.setText("Products");

        lblRemoveProductId.setText("Product No :");

        binding = org.jdesktop.beansbinding.Bindings.createAutoBinding(org.jdesktop.beansbinding.AutoBinding.UpdateStrategy.READ_WRITE, btnRemoveProduct, org.jdesktop.beansbinding.ObjectProperty.create(), txtProductId, org.jdesktop.beansbinding.BeanProperty.create("nextFocusableComponent"));
        bindingGroup.addBinding(binding);

        txtProductId.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                txtProductIdActionPerformed(evt);
            }
        });

        btnRemoveProduct.setText("Remove product");

        binding = org.jdesktop.beansbinding.Bindings.createAutoBinding(org.jdesktop.beansbinding.AutoBinding.UpdateStrategy.READ_WRITE, btnEditProduct, org.jdesktop.beansbinding.ObjectProperty.create(), btnRemoveProduct, org.jdesktop.beansbinding.BeanProperty.create("nextFocusableComponent"));
        bindingGroup.addBinding(binding);

        btnRemoveProduct.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnRemoveProductActionPerformed(evt);
            }
        });

        lblRemoveUserId.setText("User No :");

        binding = org.jdesktop.beansbinding.Bindings.createAutoBinding(org.jdesktop.beansbinding.AutoBinding.UpdateStrategy.READ_WRITE, btnRemoveUser, org.jdesktop.beansbinding.ObjectProperty.create(), txtUserId, org.jdesktop.beansbinding.BeanProperty.create("nextFocusableComponent"));
        bindingGroup.addBinding(binding);

        btnRemoveUser.setText("Remove user");

        binding = org.jdesktop.beansbinding.Bindings.createAutoBinding(org.jdesktop.beansbinding.AutoBinding.UpdateStrategy.READ_WRITE, btnEditUser, org.jdesktop.beansbinding.ObjectProperty.create(), btnRemoveUser, org.jdesktop.beansbinding.BeanProperty.create("nextFocusableComponent"));
        bindingGroup.addBinding(binding);

        btnRemoveUser.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnRemoveUserActionPerformed(evt);
            }
        });

        btnClearProductsRepo.setText("Clear products repository");

        binding = org.jdesktop.beansbinding.Bindings.createAutoBinding(org.jdesktop.beansbinding.AutoBinding.UpdateStrategy.READ_WRITE, btnRefresh, org.jdesktop.beansbinding.ObjectProperty.create(), btnClearProductsRepo, org.jdesktop.beansbinding.BeanProperty.create("nextFocusableComponent"));
        bindingGroup.addBinding(binding);

        btnClearProductsRepo.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnClearProductsRepoActionPerformed(evt);
            }
        });

        btnSaveProductsRepo.setText("Save products repository");

        binding = org.jdesktop.beansbinding.Bindings.createAutoBinding(org.jdesktop.beansbinding.AutoBinding.UpdateStrategy.READ_WRITE, btnClearProductsRepo, org.jdesktop.beansbinding.ObjectProperty.create(), btnSaveProductsRepo, org.jdesktop.beansbinding.BeanProperty.create("nextFocusableComponent"));
        bindingGroup.addBinding(binding);

        btnSaveProductsRepo.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnSaveProductsRepoActionPerformed(evt);
            }
        });

        btnAddProductsRepo.setText("Add products repository");

        binding = org.jdesktop.beansbinding.Bindings.createAutoBinding(org.jdesktop.beansbinding.AutoBinding.UpdateStrategy.READ_WRITE, btnSaveProductsRepo, org.jdesktop.beansbinding.ObjectProperty.create(), btnAddProductsRepo, org.jdesktop.beansbinding.BeanProperty.create("nextFocusableComponent"));
        bindingGroup.addBinding(binding);

        btnAddProductsRepo.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnAddProductsRepoActionPerformed(evt);
            }
        });

        btnOpenProductsRepo.setText("Open products repository");

        binding = org.jdesktop.beansbinding.Bindings.createAutoBinding(org.jdesktop.beansbinding.AutoBinding.UpdateStrategy.READ_WRITE, btnAddProductsRepo, org.jdesktop.beansbinding.ObjectProperty.create(), btnOpenProductsRepo, org.jdesktop.beansbinding.BeanProperty.create("nextFocusableComponent"));
        bindingGroup.addBinding(binding);

        btnOpenProductsRepo.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnOpenProductsRepoActionPerformed(evt);
            }
        });

        binding = org.jdesktop.beansbinding.Bindings.createAutoBinding(org.jdesktop.beansbinding.AutoBinding.UpdateStrategy.READ_WRITE, btnOpenProductsRepo, org.jdesktop.beansbinding.ObjectProperty.create(), txtProductsFileName, org.jdesktop.beansbinding.BeanProperty.create("nextFocusableComponent"));
        bindingGroup.addBinding(binding);

        lblProductsFile.setText("Products file :");

        lblUsersFile.setText("Users file :");

        cmbUserType.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Regular", "Vip", "Admin" }));

        binding = org.jdesktop.beansbinding.Bindings.createAutoBinding(org.jdesktop.beansbinding.AutoBinding.UpdateStrategy.READ_WRITE, btnAddUser, org.jdesktop.beansbinding.ObjectProperty.create(), cmbUserType, org.jdesktop.beansbinding.BeanProperty.create("nextFocusableComponent"));
        bindingGroup.addBinding(binding);

        btnRemoveReview.setText("Remove review");

        binding = org.jdesktop.beansbinding.Bindings.createAutoBinding(org.jdesktop.beansbinding.AutoBinding.UpdateStrategy.READ_WRITE, txtProductsFileName, org.jdesktop.beansbinding.ObjectProperty.create(), btnRemoveReview, org.jdesktop.beansbinding.BeanProperty.create("nextFocusableComponent"));
        bindingGroup.addBinding(binding);

        btnRemoveReview.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnRemoveReviewActionPerformed(evt);
            }
        });

        binding = org.jdesktop.beansbinding.Bindings.createAutoBinding(org.jdesktop.beansbinding.AutoBinding.UpdateStrategy.READ_WRITE, btnRemoveReview, org.jdesktop.beansbinding.ObjectProperty.create(), txtReviewId, org.jdesktop.beansbinding.BeanProperty.create("nextFocusableComponent"));
        bindingGroup.addBinding(binding);

        lblRemoveReviewId.setText("Review No :");

        btnRefresh.setText("Refresh");

        binding = org.jdesktop.beansbinding.Bindings.createAutoBinding(org.jdesktop.beansbinding.AutoBinding.UpdateStrategy.READ_WRITE, txtUsername, org.jdesktop.beansbinding.ObjectProperty.create(), btnRefresh, org.jdesktop.beansbinding.BeanProperty.create("nextFocusableComponent"));
        bindingGroup.addBinding(binding);

        btnRefresh.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnRefreshActionPerformed(evt);
            }
        });

        cmbDescription.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Pack", "Kilogram", "Litre" }));

        binding = org.jdesktop.beansbinding.Bindings.createAutoBinding(org.jdesktop.beansbinding.AutoBinding.UpdateStrategy.READ_WRITE, txtQuantity, org.jdesktop.beansbinding.ObjectProperty.create(), cmbDescription, org.jdesktop.beansbinding.BeanProperty.create("nextFocusableComponent"));
        bindingGroup.addBinding(binding);

        btnEditUser.setText("Edit user");

        binding = org.jdesktop.beansbinding.Bindings.createAutoBinding(org.jdesktop.beansbinding.AutoBinding.UpdateStrategy.READ_WRITE, txtUsersFileName, org.jdesktop.beansbinding.ObjectProperty.create(), btnEditUser, org.jdesktop.beansbinding.BeanProperty.create("nextFocusableComponent"));
        bindingGroup.addBinding(binding);

        btnEditUser.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnEditUserActionPerformed(evt);
            }
        });

        btnEditProduct.setText("Edit product");

        binding = org.jdesktop.beansbinding.Bindings.createAutoBinding(org.jdesktop.beansbinding.AutoBinding.UpdateStrategy.READ_WRITE, txtReviewId, org.jdesktop.beansbinding.ObjectProperty.create(), btnEditProduct, org.jdesktop.beansbinding.BeanProperty.create("nextFocusableComponent"));
        bindingGroup.addBinding(binding);

        btnEditProduct.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnEditProductActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 256, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(layout.createSequentialGroup()
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                                    .addGroup(layout.createSequentialGroup()
                                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                                            .addComponent(jLabel1)
                                            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                                .addComponent(jLabel3)
                                                .addComponent(jLabel2)))
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                            .addComponent(cmbUserType, 0, 126, Short.MAX_VALUE)
                                            .addComponent(txtPassword, javax.swing.GroupLayout.DEFAULT_SIZE, 126, Short.MAX_VALUE)
                                            .addComponent(txtUsername, javax.swing.GroupLayout.DEFAULT_SIZE, 126, Short.MAX_VALUE)))
                                    .addComponent(btnAddUser, javax.swing.GroupLayout.DEFAULT_SIZE, 185, Short.MAX_VALUE)
                                    .addComponent(btnClearUsersRepo, javax.swing.GroupLayout.DEFAULT_SIZE, 185, Short.MAX_VALUE)
                                    .addComponent(btnSaveUsersRepo, javax.swing.GroupLayout.DEFAULT_SIZE, 185, Short.MAX_VALUE)
                                    .addComponent(btnAddUsersRepo, javax.swing.GroupLayout.DEFAULT_SIZE, 185, Short.MAX_VALUE)
                                    .addComponent(btnOpenUsersRepo, javax.swing.GroupLayout.DEFAULT_SIZE, 185, Short.MAX_VALUE)
                                    .addComponent(txtUsersFileName, javax.swing.GroupLayout.DEFAULT_SIZE, 185, Short.MAX_VALUE)
                                    .addGroup(layout.createSequentialGroup()
                                        .addComponent(lblRemoveUserId)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addComponent(txtUserId, javax.swing.GroupLayout.PREFERRED_SIZE, 35, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                            .addComponent(btnEditUser, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                            .addComponent(btnRemoveUser, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))))
                                .addGap(36, 36, 36))
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(lblUsersFile)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)))
                        .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 297, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(btnAddProduct, javax.swing.GroupLayout.DEFAULT_SIZE, 216, Short.MAX_VALUE)
                            .addGroup(layout.createSequentialGroup()
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(lblQuantity)
                                    .addComponent(txtQuantity, javax.swing.GroupLayout.PREFERRED_SIZE, 63, javax.swing.GroupLayout.PREFERRED_SIZE))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(lblPrice)
                                    .addComponent(txtPrice, javax.swing.GroupLayout.PREFERRED_SIZE, 61, javax.swing.GroupLayout.PREFERRED_SIZE))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(lblVipPrice)
                                    .addComponent(txtVipPrice, javax.swing.GroupLayout.PREFERRED_SIZE, 62, javax.swing.GroupLayout.PREFERRED_SIZE)))
                            .addComponent(btnSaveProductsRepo, javax.swing.GroupLayout.DEFAULT_SIZE, 216, Short.MAX_VALUE)
                            .addComponent(btnAddProductsRepo, javax.swing.GroupLayout.DEFAULT_SIZE, 216, Short.MAX_VALUE)
                            .addComponent(txtProductsFileName, javax.swing.GroupLayout.DEFAULT_SIZE, 216, Short.MAX_VALUE)
                            .addComponent(btnOpenProductsRepo, javax.swing.GroupLayout.DEFAULT_SIZE, 216, Short.MAX_VALUE)
                            .addComponent(btnClearProductsRepo, javax.swing.GroupLayout.DEFAULT_SIZE, 216, Short.MAX_VALUE)
                            .addGroup(layout.createSequentialGroup()
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                                    .addComponent(lblDescription, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addComponent(lblProductType, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addComponent(lblManufacturer, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addComponent(lblProductName, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 22, Short.MAX_VALUE)
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(txtProductName, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, 121, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                                        .addComponent(txtProductType, javax.swing.GroupLayout.Alignment.LEADING)
                                        .addComponent(txtManufacturer, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 120, Short.MAX_VALUE)
                                        .addComponent(cmbDescription, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))))
                            .addComponent(lblProductsFile)
                            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                                    .addComponent(lblRemoveReviewId)
                                    .addComponent(lblRemoveProductId))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                                    .addComponent(txtReviewId)
                                    .addComponent(txtProductId, javax.swing.GroupLayout.PREFERRED_SIZE, 35, javax.swing.GroupLayout.PREFERRED_SIZE))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                    .addComponent(btnRemoveReview, javax.swing.GroupLayout.Alignment.TRAILING, 0, 0, Short.MAX_VALUE)
                                    .addComponent(btnRemoveProduct, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addComponent(btnEditProduct, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(121, 121, 121)
                        .addComponent(jLabel11)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 291, Short.MAX_VALUE)
                        .addComponent(btnRefresh)
                        .addGap(122, 122, 122)
                        .addComponent(jLabel12)
                        .addGap(338, 338, 338)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel12)
                    .addComponent(jLabel11)
                    .addComponent(btnRefresh))
                .addGap(20, 20, 20)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 624, Short.MAX_VALUE)
                    .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 624, Short.MAX_VALUE)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(txtUsername, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel1))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(txtPassword, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel2))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel3)
                            .addComponent(cmbUserType, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(btnAddUser)
                        .addGap(144, 144, 144)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(btnRemoveUser)
                            .addComponent(lblRemoveUserId)
                            .addComponent(txtUserId, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(btnEditUser)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 166, Short.MAX_VALUE)
                        .addComponent(lblUsersFile)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(txtUsersFileName, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(btnOpenUsersRepo)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(btnAddUsersRepo)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(btnSaveUsersRepo)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(btnClearUsersRepo))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(lblProductName)
                            .addComponent(txtProductName, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(txtManufacturer, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(lblManufacturer))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(txtProductType, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(lblProductType))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(cmbDescription, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(lblDescription))
                        .addGap(18, 18, 18)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(lblQuantity)
                            .addComponent(lblPrice)
                            .addComponent(lblVipPrice))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(txtQuantity, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(txtPrice, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(txtVipPrice, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(btnAddProduct)
                        .addGap(58, 58, 58)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(btnRemoveProduct)
                            .addComponent(txtProductId, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(lblRemoveProductId))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(btnEditProduct)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(btnRemoveReview)
                            .addComponent(txtReviewId, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(lblRemoveReviewId))
                        .addGap(139, 139, 139)
                        .addComponent(lblProductsFile, javax.swing.GroupLayout.PREFERRED_SIZE, 14, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(txtProductsFileName, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(btnOpenProductsRepo)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(btnAddProductsRepo)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(btnSaveProductsRepo)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(btnClearProductsRepo)))
                .addGap(20, 20, 20))
        );

        bindingGroup.bind();

        pack();
    }// </editor-fold>//GEN-END:initComponents

	private void btnAddUserActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnAddUserActionPerformed
        String username = txtUsername.getText();
		String password = txtPassword.getText();
		int userType = cmbUserType.getSelectedIndex();

		if( users.getUserByName(username) != null ){
			showError( "Username '" + username + "' already exists.", "Error user insert" );
			return;
		}

		try{
			if( txtUserId.getText().isEmpty() ) users.addUser( username, password, userType );
			else
			{
				int index = Integer.parseInt(txtUserId.getText());
				users.insertUser( index, username, password, userType);
				users.removeItem( index - 1 );
				txtUserId.setText("");
			}
        }
        catch( Exception ex ){
            // Nothing was added.
            logError( ex, "User was not inserted", "Error user insert" );
        }

		clearUserFields();
		showUsersRepository();
}//GEN-LAST:event_btnAddUserActionPerformed

	private void btnSaveUsersRepoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnSaveUsersRepoActionPerformed
        try{
            String file = txtUsersFileName.getText();
            users.saveDataBase( file );
        }
        catch( Exception ex ){
            // Nothing was saved.
            logError( ex, "User repository was not saved", "Error repo save" );
        }
}//GEN-LAST:event_btnSaveUsersRepoActionPerformed

	private void btnOpenUsersRepoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnOpenUsersRepoActionPerformed
        if( 0 != users.size() &&
                0 != JOptionPane.showConfirmDialog( this, "Are you sure to delete all users?" ) ) return;

        try{
            String file = txtUsersFileName.getText();
            users.openDataBase( file );
            showUsersRepository();
        }
        catch( Exception ex ){
            // Nothing was opened.
            logError( ex, "Question repository was not opened", "Error repo open" );
        }
}//GEN-LAST:event_btnOpenUsersRepoActionPerformed

	private void btnAddUsersRepoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnAddUsersRepoActionPerformed
        try{
            String file = txtUsersFileName.getText();
            users.addDataBase( file );
            showUsersRepository();
        }
        catch( Exception ex ){
            // Nothing was opened.
            logError( ex, "User repository was not opened", "Error repo open" );
        }
}//GEN-LAST:event_btnAddUsersRepoActionPerformed

	private void btnClearUsersRepoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnClearUsersRepoActionPerformed
        if( 0 == users.size() ||
                0 != JOptionPane.showConfirmDialog( this, "Are you sure to delete all users?" ) ) return;

        users.clearRepository();
        showUsersRepository();
}//GEN-LAST:event_btnClearUsersRepoActionPerformed

	private void txtProductTypeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_txtProductTypeActionPerformed
		// TODO add your handling code here:
}//GEN-LAST:event_txtProductTypeActionPerformed

	private void btnAddProductActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnAddProductActionPerformed
		try {
			ProductSpec spec = new ProductSpec( txtProductName.getText(),
					new Manufacturer(txtManufacturer.getText()),
					new ProductType(txtProductType.getText()),
					cmbDescription.getSelectedIndex() );
			if( txtProductId.getText().isEmpty() )
				products.addProduct( Integer.parseInt(txtQuantity.getText()),
						Double.parseDouble(txtPrice.getText()),
						Double.parseDouble(txtVipPrice.getText()),
						spec );
			else
			{
				int index = Integer.parseInt(txtProductId.getText()) - 1;
				products.insertProduct( index + 1,
						((Product)products.getItem(index)).getId(),
						Integer.parseInt(txtQuantity.getText()),
						Double.parseDouble(txtPrice.getText()),
						Double.parseDouble(txtVipPrice.getText()),
						spec );
				// If insertion is successful, the old product with the same ID will be removed.
				products.removeItem( index );
				txtProductId.setText("");
			}
		} catch (Exception ex){
            // Nothing was added.
            logError( ex, "Product was not inserted", "Error product insert" );
		}

		clearProductFields();
		showProductsRepository();
}//GEN-LAST:event_btnAddProductActionPerformed

	private void txtProductIdActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_txtProductIdActionPerformed
		// TODO add your handling code here:
}//GEN-LAST:event_txtProductIdActionPerformed

	private void btnRemoveProductActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnRemoveProductActionPerformed
		try {
			int id = Integer.parseInt( txtProductId.getText() ) - 1;
			products.removeItem(id);
		} catch (Exception ex) {
			if( txtProductId.getText().equals("") ) return;
			logError( ex, "Product was not removed", "Error product remove" );
		}

		showProductsRepository();
		txtProductId.setText("");
}//GEN-LAST:event_btnRemoveProductActionPerformed

	private void btnRemoveUserActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnRemoveUserActionPerformed
		try {
			int id = Integer.parseInt( txtUserId.getText() ) - 1;
			users.removeItem(id);
		} catch (Exception ex) {
			if( txtUserId.getText().equals("") ) return;
			logError( ex, "User was not removed", "Error user remove" );
		}

		showUsersRepository();
		txtUserId.setText("");
}//GEN-LAST:event_btnRemoveUserActionPerformed

	private void btnOpenProductsRepoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnOpenProductsRepoActionPerformed
        if( 0 != products.size() &&
                0 != JOptionPane.showConfirmDialog( this, "Are you sure to delete all products?" ) ) return;

        try{
            String file = txtProductsFileName.getText();
            products.openDataBase( file );
            showProductsRepository();
        }
        catch( Exception ex ){
            // Nothing was opened.
            logError( ex, "Products repository was not opened", "Error repo open" );
        }
	}//GEN-LAST:event_btnOpenProductsRepoActionPerformed

	private void btnAddProductsRepoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnAddProductsRepoActionPerformed
        try{
            String file = txtProductsFileName.getText();
            products.addDataBase( file );
            showProductsRepository();
        }
        catch( Exception ex ){
            // Nothing was opened.
            logError( ex, "Products repository was not opened", "Error repo open" );
        }
	}//GEN-LAST:event_btnAddProductsRepoActionPerformed

	private void btnSaveProductsRepoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnSaveProductsRepoActionPerformed
        try{
            String file = txtProductsFileName.getText();
            products.saveDataBase( file );
        }
        catch( Exception ex ){
            // Nothing was saved.
            logError( ex, "Products repository was not saved", "Error repo save" );
        }
}//GEN-LAST:event_btnSaveProductsRepoActionPerformed

	private void btnClearProductsRepoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnClearProductsRepoActionPerformed
        if( 0 == products.size() ||
                0 != JOptionPane.showConfirmDialog( this, "Are you sure to delete all products?" ) ) return;

        products.clearRepository();
        showProductsRepository();
	}//GEN-LAST:event_btnClearProductsRepoActionPerformed

	private void btnRemoveReviewActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnRemoveReviewActionPerformed
		try {
			int productid = Integer.parseInt( txtProductId.getText() ) - 1;
			int reviewid = Integer.parseInt( txtReviewId.getText() ) - 1;
			((Product)products.getItem(productid)).removeReview(reviewid);
		} catch (Exception ex) {
			if( txtProductId.getText().equals("") || txtReviewId.getText().equals("") ) return;
			logError( ex, "Review was not remvoed", "Error review remove" );
		}

		showProductsRepository();
		txtProductId.setText("");
		txtReviewId.setText("");
	}//GEN-LAST:event_btnRemoveReviewActionPerformed

	private void btnRefreshActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnRefreshActionPerformed
		reloadRepositories();
	}//GEN-LAST:event_btnRefreshActionPerformed

	private void btnEditUserActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnEditUserActionPerformed
		try {
			User user = (User) users.getItem(Integer.parseInt(txtUserId.getText()) - 1);
			txtUsername.setText( user.getUsername() );
			txtPassword.setText( user.getPassword() );
			cmbUserType.setSelectedIndex( user.getType() );
		} catch (Exception ex) {
			if( txtUserId.getText().equals("") ) return;
			logError( ex, "User was not edited", "Error user edit" );
		}

		txtUserId.setText("");
}//GEN-LAST:event_btnEditUserActionPerformed

	private void btnEditProductActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnEditProductActionPerformed
		try {
			Product product = (Product) products.getItem(Integer.parseInt(txtProductId.getText()) - 1);
			ProductSpec spec = product.getSpec();
			txtProductName.setText(product.getProductName());
			txtManufacturer.setText(spec.getManufacturer().toString());
			txtProductType.setText(spec.getProductType().toString());
			cmbDescription.setSelectedIndex(spec.getDescription());
			txtQuantity.setText(String.format("%d", product.getQuantity()));
			txtPrice.setText(String.format("%f", product.getPrice()));
			txtVipPrice.setText(String.format("%f", product.getVipPrice()));
		} catch (Exception ex) {
			if( txtProductId.getText().equals("") ) return;
			logError( ex, "Product was not edited", "Error product edit" );
		}

		txtProductId.setText("");
}//GEN-LAST:event_btnEditProductActionPerformed

    /**
    * @param args the command line arguments
    */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new AdminArea().setVisible(true);
            }
        });
    }


    // Private
    //
	private void reloadRepositories(){
        try{
            users.openDataBase(fileUsers);
			showUsersRepository();
        }
        catch( Exception ex ){
            // Nothing was opened.
			System.out.println("Failed to open repository file. Reason: " + ex.getMessage());
        }

        try{
			products.openDataBase(fileProducts);
			showProductsRepository();
        }
        catch( Exception ex ){
            // Nothing was opened.
			System.out.println("Failed to open repository file. Reason: " + ex.getMessage());
        }
	}

	private void showUsersRepository(){
        txtareaUsers.setText( users.toString() );
	}

	private void showProductsRepository(){
		txtareaProducts.setText( products.toString() );
	}

    private void clearUserFields(){
        txtUsername.setText( "" );
        txtPassword.setText( "" );
        cmbUserType.setSelectedIndex(0);
    }

	private void clearProductFields(){
		txtProductName.setText("");
		txtManufacturer.setText("");
		txtProductType.setText("");
		cmbDescription.setSelectedIndex(0);
		txtQuantity.setText("0");
		txtPrice.setText("0.0");
		txtVipPrice.setText("0.0");
	}

    private static void logError( Exception ex, String reason, String title ){
        //ex.printStackTrace();
        //System.out.println();
        System.out.println( reason + ".   Reason: " + ex.getMessage() );
        JOptionPane.showMessageDialog( null, reason + "\nReason: " + ex.getMessage(),
                title, JOptionPane.WARNING_MESSAGE );
    }

	private static void showError( String reason, String title ){
        JOptionPane.showMessageDialog( null, reason,
                title, JOptionPane.WARNING_MESSAGE );
	}

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnAddProduct;
    private javax.swing.JButton btnAddProductsRepo;
    private javax.swing.JButton btnAddUser;
    private javax.swing.JButton btnAddUsersRepo;
    private javax.swing.JButton btnClearProductsRepo;
    private javax.swing.JButton btnClearUsersRepo;
    private javax.swing.JButton btnEditProduct;
    private javax.swing.JButton btnEditUser;
    private javax.swing.JButton btnOpenProductsRepo;
    private javax.swing.JButton btnOpenUsersRepo;
    private javax.swing.JButton btnRefresh;
    private javax.swing.JButton btnRemoveProduct;
    private javax.swing.JButton btnRemoveReview;
    private javax.swing.JButton btnRemoveUser;
    private javax.swing.JButton btnSaveProductsRepo;
    private javax.swing.JButton btnSaveUsersRepo;
    private javax.swing.JComboBox cmbDescription;
    private javax.swing.JComboBox cmbUserType;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JLabel lblDescription;
    private javax.swing.JLabel lblManufacturer;
    private javax.swing.JLabel lblPrice;
    private javax.swing.JLabel lblProductName;
    private javax.swing.JLabel lblProductType;
    private javax.swing.JLabel lblProductsFile;
    private javax.swing.JLabel lblQuantity;
    private javax.swing.JLabel lblRemoveProductId;
    private javax.swing.JLabel lblRemoveReviewId;
    private javax.swing.JLabel lblRemoveUserId;
    private javax.swing.JLabel lblUsersFile;
    private javax.swing.JLabel lblVipPrice;
    private javax.swing.JTextField txtManufacturer;
    private javax.swing.JTextField txtPassword;
    private javax.swing.JTextField txtPrice;
    private javax.swing.JTextField txtProductId;
    private javax.swing.JTextField txtProductName;
    private javax.swing.JTextField txtProductType;
    private javax.swing.JTextField txtProductsFileName;
    private javax.swing.JTextField txtQuantity;
    private javax.swing.JTextField txtReviewId;
    private javax.swing.JTextField txtUserId;
    private javax.swing.JTextField txtUsername;
    private javax.swing.JTextField txtUsersFileName;
    private javax.swing.JTextField txtVipPrice;
    private javax.swing.JTextArea txtareaProducts;
    private javax.swing.JTextArea txtareaUsers;
    private org.jdesktop.beansbinding.BindingGroup bindingGroup;
    // End of variables declaration//GEN-END:variables

}
