
package zoomarket;

import java.util.Iterator;
import java.util.Vector;


public class Catalogue extends Repository{

	public void addProduct( int quantity, double price, double vipPrice, ProductSpec spec ) throws ZooException{
		int id = getAvailableId();
		addItem( new Product( id, quantity, price, vipPrice, spec ) );
	}

    public void addProduct( int id, int quantity, double price, double vipPrice, ProductSpec spec ) throws ZooException{
        addItem( new Product(id, quantity, price, vipPrice, spec) );
    }

    public void insertProduct( int dest, int quantity, double price, double vipPrice, ProductSpec spec ) throws ZooException{
		int id = getAvailableId();
        insertItem( dest, new Product(id, quantity, price, vipPrice, spec) );
    }

    public void insertProduct( int dest, int id, int quantity, double price, double vipPrice, ProductSpec spec ) throws ZooException{
        insertItem( dest, new Product(id, quantity, price, vipPrice, spec) );
    }

	public Vector<String> getListProductNames(){
        Vector<String> lstProductNames = new Vector<String>();

		Iterator iter = items.iterator();
		while( iter.hasNext() ){
			lstProductNames.add( ((Product) iter.next()).getProductName() );
		}

		return lstProductNames;
	}


	//// Private methods
	//
	private int getAvailableId(){
		// Get available product id with reusing deleted product IDs. Product IDs start from 1.
		int existing_id = 0, id = 0;
		Iterator iter = null;

		while( existing_id == id ){
			id += 1;
			iter = items.iterator();
			while( iter.hasNext() ){
				existing_id = ((Product) iter.next()).getId();
				if( existing_id == id ) break;
			}
		}

		return id;
	}

}
