
package zoomarket;

import java.io.Serializable;
import java.util.Date;


public class Review implements Serializable {

    private String content;
    private String username;
    private Date date;

    public Review(String content, String name, Date date) throws ZooException{
        setContent( content );
        setUserName( name );
        setDate( date );
    }

    public void setContent( String content ) throws ZooException{
        if( content == null || content.equals("") ) throw new ZooException("Empty Content");
        this.content = content;
    }

    public void setUserName( String username ) throws ZooException{
        if( username == null || username.equals("") ) throw new ZooException("Empty User Name");
        this.username = username;
    }

    public void setDate( Date date ) throws ZooException{
        if( date == null ) throw new ZooException("Empty Date");
        this.date = date;
    }

    public String getContent(){
        return content;
    }

    public String getName(){
        return username;
    }

    public Date getDate(){
        return date;
    }

    public String toString()
    {
        StringBuffer buffer = new StringBuffer();
        buffer.append( "\nUsername:    " );
        buffer.append( username );
        buffer.append( "\n" );
        buffer.append( content );
        buffer.append( "\nDate:         " );
        buffer.append( date );
        buffer.append( "\n" );
        return buffer.toString();
    }
}
