
package zoomarket;

import javax.swing.JOptionPane;
import javax.swing.ListSelectionModel;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;


public class ZooMarket extends javax.swing.JFrame {
    private Catalogue catalogue;
	private UserManager usermanager;
    private String username;
    private int usertype;
	private javax.swing.JFrame adminFrame;

	private final String fileUsers = "users";
	private final String fileProducts = "products";


    /** Creates new form ZooMarket */
    public ZooMarket() {
        initComponents();

		setTitle("Zoo Market");
		setResizable(false);

        usermanager = new UserManager();
		catalogue = new Catalogue();

		adminFrame = new AdminArea();
		adminFrame.setTitle("Admin Area");
		adminFrame.setDefaultCloseOperation(HIDE_ON_CLOSE);
		adminFrame.setResizable(false);

		reloadDatabases();

		lstProducts.getSelectionModel().addListSelectionListener(new ListProductsListeneer());
		lstProducts.getSelectionModel().setSelectionMode(ListSelectionModel.SINGLE_SELECTION);

		updateUserType(-1);
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        bindingGroup = new org.jdesktop.beansbinding.BindingGroup();

        txtUsername = new javax.swing.JTextField();
        txtPassword = new javax.swing.JPasswordField();
        btnLogIn = new javax.swing.JButton();
        btnRegister = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        lstProducts = new javax.swing.JList();
        jScrollPane2 = new javax.swing.JScrollPane();
        txtProductDesc = new javax.swing.JTextArea();
        jScrollPane3 = new javax.swing.JScrollPane();
        txtProductReviews = new javax.swing.JTextArea();
        jScrollPane4 = new javax.swing.JScrollPane();
        txtNewReview = new javax.swing.JTextArea();
        btnAddReview = new javax.swing.JButton();
        lblUsername = new javax.swing.JLabel();
        lblPassword = new javax.swing.JLabel();
        btnAdminArea = new javax.swing.JButton();
        btnRefreshProducts = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        org.jdesktop.beansbinding.Binding binding = org.jdesktop.beansbinding.Bindings.createAutoBinding(org.jdesktop.beansbinding.AutoBinding.UpdateStrategy.READ_WRITE, txtPassword, org.jdesktop.beansbinding.ObjectProperty.create(), txtUsername, org.jdesktop.beansbinding.BeanProperty.create("nextFocusableComponent"));
        bindingGroup.addBinding(binding);

        binding = org.jdesktop.beansbinding.Bindings.createAutoBinding(org.jdesktop.beansbinding.AutoBinding.UpdateStrategy.READ_WRITE, btnLogIn, org.jdesktop.beansbinding.ObjectProperty.create(), txtPassword, org.jdesktop.beansbinding.BeanProperty.create("nextFocusableComponent"));
        bindingGroup.addBinding(binding);

        btnLogIn.setText("Log in");

        binding = org.jdesktop.beansbinding.Bindings.createAutoBinding(org.jdesktop.beansbinding.AutoBinding.UpdateStrategy.READ_WRITE, btnRegister, org.jdesktop.beansbinding.ObjectProperty.create(), btnLogIn, org.jdesktop.beansbinding.BeanProperty.create("nextFocusableComponent"));
        bindingGroup.addBinding(binding);

        btnLogIn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnLogInActionPerformed(evt);
            }
        });

        btnRegister.setText("Register");

        binding = org.jdesktop.beansbinding.Bindings.createAutoBinding(org.jdesktop.beansbinding.AutoBinding.UpdateStrategy.READ_WRITE, btnAdminArea, org.jdesktop.beansbinding.ObjectProperty.create(), btnRegister, org.jdesktop.beansbinding.BeanProperty.create("nextFocusableComponent"));
        bindingGroup.addBinding(binding);

        btnRegister.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnRegisterActionPerformed(evt);
            }
        });

        jScrollPane1.setViewportView(lstProducts);

        txtProductDesc.setColumns(20);
        txtProductDesc.setRows(5);
        jScrollPane2.setViewportView(txtProductDesc);

        txtProductReviews.setColumns(20);
        txtProductReviews.setRows(5);
        jScrollPane3.setViewportView(txtProductReviews);

        txtNewReview.setColumns(20);
        txtNewReview.setRows(5);
        jScrollPane4.setViewportView(txtNewReview);

        btnAddReview.setText("Add review");
        btnAddReview.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnAddReviewActionPerformed(evt);
            }
        });

        lblUsername.setText("Username:");

        lblPassword.setText("Password:");

        btnAdminArea.setText("Edit database");

        binding = org.jdesktop.beansbinding.Bindings.createAutoBinding(org.jdesktop.beansbinding.AutoBinding.UpdateStrategy.READ_WRITE, btnRefreshProducts, org.jdesktop.beansbinding.ObjectProperty.create(), btnAdminArea, org.jdesktop.beansbinding.BeanProperty.create("nextFocusableComponent"));
        bindingGroup.addBinding(binding);

        btnAdminArea.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnAdminAreaActionPerformed(evt);
            }
        });

        btnRefreshProducts.setText("Refresh");

        binding = org.jdesktop.beansbinding.Bindings.createAutoBinding(org.jdesktop.beansbinding.AutoBinding.UpdateStrategy.READ_WRITE, txtUsername, org.jdesktop.beansbinding.ObjectProperty.create(), btnRefreshProducts, org.jdesktop.beansbinding.BeanProperty.create("nextFocusableComponent"));
        bindingGroup.addBinding(binding);

        btnRefreshProducts.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnRefreshProductsActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 236, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addComponent(btnAdminArea, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addGap(18, 18, 18)
                        .addComponent(btnRefreshProducts)))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 22, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(txtUsername, javax.swing.GroupLayout.PREFERRED_SIZE, 143, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(lblUsername))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(txtPassword, javax.swing.GroupLayout.PREFERRED_SIZE, 139, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 91, Short.MAX_VALUE)
                                .addComponent(btnLogIn)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(btnRegister))
                            .addComponent(lblPassword)))
                    .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 519, Short.MAX_VALUE)
                    .addComponent(jScrollPane3, javax.swing.GroupLayout.DEFAULT_SIZE, 519, Short.MAX_VALUE)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jScrollPane4, javax.swing.GroupLayout.PREFERRED_SIZE, 422, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(btnAddReview, javax.swing.GroupLayout.DEFAULT_SIZE, 87, Short.MAX_VALUE)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(31, 31, 31)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(btnRegister)
                            .addComponent(btnLogIn)))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(31, 31, 31)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(btnAdminArea)
                            .addComponent(btnRefreshProducts)))
                    .addGroup(layout.createSequentialGroup()
                        .addContainerGap()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(lblUsername)
                            .addComponent(lblPassword))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(txtPassword, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(txtUsername, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))))
                .addGap(31, 31, 31)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 180, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jScrollPane3, javax.swing.GroupLayout.PREFERRED_SIZE, 240, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(btnAddReview)
                            .addComponent(jScrollPane4, javax.swing.GroupLayout.DEFAULT_SIZE, 129, Short.MAX_VALUE)))
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 561, Short.MAX_VALUE))
                .addContainerGap())
        );

        bindingGroup.bind();

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void btnRegisterActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnRegisterActionPerformed
        String strUsername = txtUsername.getText();
		String strPassword = new String(txtPassword.getPassword());
		if( strUsername.isEmpty() && strPassword.isEmpty() ) return;

		User user = usermanager.getUserByName(strUsername);

		if( user != null ){
			showError( "Username '" + strUsername + "' already exists.", "Error user register" );
			return;
		}
		try {
			usermanager.addUser(strUsername, strPassword, 0);
		} catch (ZooException ex) {
			logError( ex, "User was not added", "Error user register" );
			return;
		}
		try {
			usermanager.saveDataBase(fileUsers);
		} catch (ZooException ex) {
			logError( ex, "Users database was not saved", "Error user register" );
			return;
		}

		login(strUsername, strPassword);
}//GEN-LAST:event_btnRegisterActionPerformed

	private void btnLogInActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnLogInActionPerformed
		if( username == null ){
			String strUsername = txtUsername.getText();
			String strPassword = new String(txtPassword.getPassword());
			if( strUsername.isEmpty() && strPassword.isEmpty() ) return;
			login(strUsername, strPassword);
		}
		else{
			username = null;
			updateUserType(-1);
			btnLogIn.setText("Log in");
		}
	}//GEN-LAST:event_btnLogInActionPerformed

	private void btnAddReviewActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnAddReviewActionPerformed
		int index = lstProducts.getSelectionModel().getLeadSelectionIndex();
		if( index < 0 ) return;
		try {
			((Product)catalogue.getItem(index)).addReview( txtNewReview.getText(), username );
			txtNewReview.setText("");
			printSelectedProduct();
		} catch (ZooException ex) {
			logError( ex, "Review was not added", "Error review insert" );
			return;
		}
		try {
			catalogue.saveDataBase(fileProducts);
		} catch (ZooException ex) {
			logError( ex, "Products database was not saved", "Error review insert" );
			return;
		}
	}//GEN-LAST:event_btnAddReviewActionPerformed

	private void btnAdminAreaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnAdminAreaActionPerformed
		adminFrame.setVisible(true);
}//GEN-LAST:event_btnAdminAreaActionPerformed

	private void btnRefreshProductsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnRefreshProductsActionPerformed
		reloadDatabases();
	}//GEN-LAST:event_btnRefreshProductsActionPerformed

    /**
    * @param args the command line arguments
    */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
				new ZooMarket().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnAddReview;
    private javax.swing.JButton btnAdminArea;
    private javax.swing.JButton btnLogIn;
    private javax.swing.JButton btnRefreshProducts;
    private javax.swing.JButton btnRegister;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JScrollPane jScrollPane4;
    private javax.swing.JLabel lblPassword;
    private javax.swing.JLabel lblUsername;
    private javax.swing.JList lstProducts;
    private javax.swing.JTextArea txtNewReview;
    private javax.swing.JPasswordField txtPassword;
    private javax.swing.JTextArea txtProductDesc;
    private javax.swing.JTextArea txtProductReviews;
    private javax.swing.JTextField txtUsername;
    private org.jdesktop.beansbinding.BindingGroup bindingGroup;
    // End of variables declaration//GEN-END:variables


	class ListProductsListeneer implements ListSelectionListener {
		public void valueChanged(ListSelectionEvent e) {
			printSelectedProduct();
		}
	}

	private void login(String strUsername, String strPassword){
		User user = usermanager.getUser( strUsername, strPassword );

		if( user == null ) {
			showError( "Username '" + strUsername + "' and password '" + strPassword + "' don't exist.", "Error log in" );
			return;
		}
		username = user.getUsername();
		updateUserType(user.getType());
		btnLogIn.setText("Log out " + username);

		txtUsername.setText("");
		txtPassword.setText("");
	}

	private void reloadDatabases(){
        try{
            usermanager.openDataBase(fileUsers);
			catalogue.openDataBase(fileProducts);
        }
        catch( Exception ex ){
            // Nothing was opened.
			return;
        }

		lstProducts.setListData(catalogue.getListProductNames());
	}

	private void updateUserType( int usertype ){
		this.usertype = usertype;
		boolean enabled = (usertype != -1);
		txtNewReview.setEditable(enabled);
		btnAddReview.setEnabled(enabled);
		btnAdminArea.setEnabled((usertype == 2));
	}
	
	private void printSelectedProduct(){
		int index = lstProducts.getLeadSelectionIndex();
		Product prod;
		try {
			prod = (Product) catalogue.getItem(index);
			txtProductDesc.setText( prod.getProductDescription() );
			txtProductReviews.setText( prod.getProductReviews() );
		} catch (ZooException ex) {
			return;
		}
	}

    private static void logError( Exception ex, String reason, String title ){
        //ex.printStackTrace();
        //System.out.println();
        System.out.println( reason + ".   Reason: " + ex.getMessage() );
        JOptionPane.showMessageDialog( null, reason + "\nReason: " + ex.getMessage(),
                title, JOptionPane.WARNING_MESSAGE );
    }

	private static void showError( String reason, String title ){
        JOptionPane.showMessageDialog( null, reason,
                title, JOptionPane.WARNING_MESSAGE );
	}
}
